<template>
  <!-- eslint-disable max-len -->
  <main id="main" style="margin-top: -20px; padding-bottom: 50px;">
    <div class="container">
      <div class="form">
        <div class="row">
          <div class="col-md-12 col-lg-8">
            <div class="section-header">
              <h2>Property Types</h2>
            </div>
          </div>
        </div>
        <div v-if="checkAccess" class="row">
          <div class="col">
            <listView
              :items="propertyTypes"
              :showNew="true"
              :editable="true"
              :deleteable="true"
              :displayColumns="columns"
              :sortKey="'description'"
              @onEdit="Edit"
              @onDelete="Delete"
              @onNew="New"
            />
          </div>
        </div>
        <div v-else class="row">
          <div class="col">
            <alert
              :text="'You don\'t have permission to view this page'"
              :type="'ERROR'"
            />
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
/* eslint-disable */
import { mapState, mapActions } from 'vuex'

import Log from '../../../assets/Log'
import alert from '../../shared/alert'
import listView from '../../shared/listView.vue'

export default {
  name: 'PropertyTypeList',
  components: {
    listView,
    alert,
  },
  data() {
    return {
      columns: ['propertyUsageType', 'description'],
    }
  },
  methods: {
    ...mapActions('propertyTypes', ['getPropertyTypes', 'deletePropertyType']),
    New() {
      this.$router.push('/propertyType/new')
    },
    Edit(item) {
      this.$router.push({
        path: `/propertyType/${item.id}`,
      })
    },
    Delete(item) {
      this.deletePropertyType(item.id)
    },
  },
  mounted() {
    this.getPropertyTypes()
  },
  computed: {
    ...mapState('propertyTypes', ['propertyTypes']),
    checkAccess() {
      if (Log.getUser().role === 'Super Admin') {
        return true
      } else {
        return false
      }
    },
  },
}
</script>
